/* -*- mode: c++ -*- */

#include <stdlib.h>
#include <stdio.h>
#include "vector_util.h"

void do_add(size_t N, int *vec1, int *vec2, int *result) {
  for(int i = 0; i < N; i++) {
    result[i] = vec1[i] + vec2[i];
  }
}

int main(int argc, char *argv[]) {
  if(argc != 2) {
    fprintf(stderr, "Usage: %s N\n", argv[0]);
    exit(1);
  }

  int *a, *b, *c;
  int N;

  N = atoi(argv[1]);
  
  printf("Generating random vectors of size %d\n", N);

  a = generate_vector(N);
  b = generate_vector(N);
  c = (int *) malloc(sizeof(int) * N);

  printf("Adding both vectors\n");
  do_add(N, a, b, c);

  printf("Checking result ...\n");
  if(check_addition(N, a, b, c)) {
    printf("Result okay!\n");
  }
  
  return 0;

}
